'Implementation of the long division algorithm in TRS-80 BASIC
'- Takes two numbers A and B, then divides them
'- Division is carried out until it either completes, or repeats
'- Prints digits as it computes
'- Handles 14 digit numbers

CLS

'I would like to define A,B,C as int, but that limits us to 15 bits which is no fun
DEFINT D,F,I,S,Z
DEFSTR E

'A Dividend
'B Divisor
'C Remainder
'D Cursor offset
'E Character to write
'F Index of found repetition (Full name "Found")
'I Index into the remainder accumulator (Full name "Index")
'R Remainder accumulator array
'S Accumulator size
'T Temporary mod storage
'Z Counter for repeading decimal detection

'With 15 slots we should cover all cases.
'We can increase, but it obviously gets very slow.
'For the repetition to be detected,
'it must happen within the first S digits
S=15
DIM R(S)

Index=0
D=0

INPUT "Enter dividend";A
INPUT "Enter divisor";B
IF Fix(B)=0 THEN PRINT "Divisor cannot be zero":END
IF A<0 OR B<0 THEN PRINT "Number must be positive":END
'Short circuit if A is zero
IF A=0 THEN PRINT "0":END

CLS
'Print "A/B="
CALL @write(MID$(STR$(A),2)+"/"+MID$(STR$(B),2)+"=")

'First computation outside of loop to handle numbers that are evenly divisible

'"A\B" for large numbers
T=Fix(A/B)
'STR$ adds a nasty space before the number
CALL @write(MID$(STR$(T),2))
'"A MOD B" for large numbers
C=A-T*B

'Take remainder and add a zero
A=C*10
'Print decimal point if we are not done yet
IF A>0 THEN : CALL @write(".")

'Calculation routine
@calc
IF A=0 THEN END
T=Fix(A/B) 'division
C=A-T*B 'mod

'Format and print current digit
CALL @write(MID$(STR$(T),2))

'End if no more remainder (result is non-repeating)
IF C=0 THEN END

'Search for an existing remainder
Found=0
FOR Z=0 TO Index
IF R(Z)=C THEN Found=Z+1
NEXT
'End if the remainder has been found (result is repeating)
IF Found>0 THEN GOTO @repeating

'Fill remainder array with every step until it is full
R(Index)=C
IF Index<S THEN Index=Index+1

'Process next number
A=C*10
GOTO @calc

@repeating
'Overwrite the last digit
PRINT@ D-1,"..."
E$=STR$(Found)
IF Found>1 THEN E$=E$+"nd" ELSE E$=E$+"st"
IF Found>2 THEN E$=E$+"rd"
IF Found>3 THEN E$=E$+"th"
PRINT "The number repeats from the"+E$+" digit"
PRINT "after the decimal"